"{ Package: 'stx:libview' }"

AbstractBorder subclass:#RoundButtonBorder
	instanceVariableNames:'color'
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Support'
!

!RoundButtonBorder class methodsFor:'documentation'!

documentation
"
    experimental

    [author:]
        Claus Gittinger
"
! !

!RoundButtonBorder methodsFor:'accessing'!

color
    "the color of the border"

    ^ color
!

color:aColor
    "set the color of the border"

    width ~~ 0 ifTrue:[
        self assert:aColor notNil.
    ].
    color := aColor
!

width
    ^ 2
! !

!RoundButtonBorder methodsFor:'displaying'!

displayOn:aGC forDisplayBox:aRectangle
    |oldPaint left top w h|

    color isNil ifTrue:[ ^ self].

    oldPaint := aGC paint.
    aGC paint:color.
    left := aRectangle left.
    top := aRectangle top.
    w := aRectangle width.
    h := aRectangle height.

    aGC displayRectangleX:left y:top width:w height:h.

    aGC paint:color slightlyLightened.
    aGC displayPointX:left+2 y:top.
    aGC displayPointX:left+1 y:top+1.
    aGC displayPointX:left y:top+2.

    aGC displayPointX:left+2 y:top+h-1.
    aGC displayPointX:left+1 y:top+h-2.
    aGC displayPointX:left y:top+h-3.

    aGC displayPointX:left+w-3 y:top.
    aGC displayPointX:left+w-2 y:top+1.
    aGC displayPointX:left+w-1 y:top+2.

    aGC displayPointX:left+w-3 y:top+h-1.
    aGC displayPointX:left+w-2 y:top+h-2.
    aGC displayPointX:left+w-1 y:top+h-3.

    aGC paint:color lightened.
    aGC displayPointX:left+1 y:top.
    aGC displayPointX:left y:top+1.

    aGC displayPointX:left+1 y:top+h-1.
    aGC displayPointX:left y:top+h-2.

    aGC displayPointX:left+w-2 y:top.
    aGC displayPointX:left+w-1 y:top+1.

    aGC displayPointX:left+w-2 y:top+h-1.
    aGC displayPointX:left+w-1 y:top+h-2.

    aGC paint:(aGC container ? aGC) viewBackground.
    aGC displayPointX:left y:top.
    aGC displayPointX:left+w-1 y:top.

    aGC displayPointX:left y:top+h-1.
    aGC displayPointX:left+w-1 y:top+h-1.

    aGC paint:oldPaint.

    "
     |v b|

     v := View new openAndWait.
     b := RoundButtonBorder width:2 color:Color grey.
     b displayOn:v forDisplayBox:(0@0 corner:v extent).
    "
! !

!RoundButtonBorder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libview/RoundButtonBorder.st,v 1.2 2009-10-29 17:24:43 cg Exp $'
! !
